
#include "SDL/SDL.h"

#include "enemy.h"
#include "player.h"

static int wait_sec=40;
SDL_Surface *screen;
Uint32 green;
Uint32 white;

extern struct player player;

/* FPS $BD4@0(B */
void wait_next()
{
	static Uint32 next=0;
	Uint32 now = SDL_GetTicks();
	if ( next == 0 ) {
		next = now+wait_sec;
	}
	if ( now>next ) {
		next = now+wait_sec;
	} else {
		SDL_Delay( next-now );
		next=SDL_GetTicks()+wait_sec;
	}
}

static int key( Uint8 *keystate )
{
	if ( keystate[SDLK_ESCAPE] )
		return 1;

	return 0;
}

int main()
{
	SDL_Init( SDL_INIT_VIDEO );
	screen = SDL_SetVideoMode( 300, 300, 0, SDL_SWSURFACE|SDL_DOUBLEBUF );

	/* color key $BMQ(B */
	green = SDL_MapRGB( screen->format, 0, 255, 0 );
	/* $BGX7J$OGr$K$7$h$&(B */
	white = SDL_MapRGB( screen->format, 0xff, 0xff, 0xff );

	player.x = 0;
	player.y = 0;

	player_init();
	enemy_init();

	while ( 1 ) {
		Uint8 *keystate;
		SDL_PumpEvents();
		
		keystate = SDL_GetKeyState(NULL);
		if ( key( keystate ) )
			break;

		player_move( keystate );
		enemy_move();

		player_draw();
		enemy_draw();

		wait_next();
		SDL_UpdateRect( screen, 0,0, 300, 300 );
		SDL_FillRect( screen, NULL, white );
	}

	enemy_destroy();
	player_destroy();

	SDL_Quit();

	return 0;
}
